--[[
	Author: Darcey.Lloyd@gmail.com

	USEFUL TO GET FRAME NAME IN GAME CHAT:
	/run print(GetMouseFocus():GetName() .. "\n")
--]]



-- Addon Global Variables (shared between files but not addons). addon var name can be renamed
local AddOnName, addon = ...;
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #


-- Libs
-- NOTE: These libs rely on quite a lot of includes, see embeds.xml
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
local aceAddon = LibStub("AceAddon-3.0"):NewAddon(addon.name, "AceConsole-3.0")
local AceGUI = LibStub("AceGUI-3.0")
-- local icon = LibStub("LibDBIcon-1.0")
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




addon.setupMenu = function()
   -- Main page
    addon.setupMenuMainPage();

	-- MainBar page
	addon.setupMenuMainBar();

	-- WorldMap page
	addon.setupMenuWorldMap();

	-- MiniMap page
	addon.setupMenuMiniMap();

end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #







addon.setupMenuMainPage = function()
	local x = 10;
	local y = -10;

	-- Frame for the page
	-- DMouse.menu.mainPage = DTools.createTestFrame(400,400,"TOPLEFT",0,0); -- For visual without opening menu
	addon.menu.mainPage = CreateFrame( "Frame", "DCoordsMenuMainPage", UIParent );

    -- Page title
    -- function(frame,label,fontSize,x,y,r,g,b,font)
    DTools.createText(addon.menu.mainPage,addon.name .. " v" .. addon.version,addon.menu.titleTextSize,"LEFT",x,y,1,1,1)
	y = y - 40; -- estimate height of item


	DTools.createText(addon.menu.mainPage,"Choose which feature you would like to configure via the menu pages on the left.",addon.menu.textSize,"LEFT",x,y,1,1,1)
	y = y - 40; -- estimate height of item


	-- Setup menu, add main page and get DTools.menu api ref
	addon.menu.api = DTools.createAddonMenu(
        "DCoords Classic",addon.version,"darcey.lloyd@gmail.com",
        addon.menu.mainPage
    );
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #








addon.setupMenuMainBar = function()
	local x = 10;
	local y = -10;

	-- Frame for the page
	-- DMouse.menu.mainPage = DTools.createTestFrame(400,400,"TOPLEFT",0,0); -- For visual without opening menu
	addon.menu.mainBar = CreateFrame( "Frame", "DCoordsMenuMainBarPage", UIParent );

    -- Page title
    -- function(frame,label,fontSize,x,y,r,g,b,font)
    DTools.createText(addon.menu.mainBar,addon.name .. " v" .. addon.version .. " - Main bar",addon.menu.titleTextSize,"LEFT",x,y,1,1,1)
	y = y - 40; -- estimate height of item


	-- Checkbox: Enable / Disable
	local cb1ClickHandler = function(checked)
		DCoordsDB["MainBar"].enabled  = checked;
		if (DCoordsDB["MainBar"].enabled == true) then
			addon.mainBar.frame:Show();
		else
			addon.mainBar.frame:Hide();
		end
    end
	local cb1 = DTools.createCheckbox(
        "cb1",addon.menu.mainBar,"Enable main coordinates bar?",
        x,y,
        DCoordsDB["MainBar"].enabled,
        cb1ClickHandler
    )
	y = y - 30; -- estimate height of item




	-- Checkbox: Zone Enable / Disable
	local cb2ClickHandler = function(checked)
		DCoordsDB["MainBar"].showZone  = checked;
    end
	local cb2 = DTools.createCheckbox(
        "cb2",addon.menu.mainBar,"Show zone?",
        x,y,
        DCoordsDB["MainBar"].showZone,
        cb2ClickHandler
    )
	y = y - 30; -- estimate height of item



	-- Checkbox: Zone Enable / Disable
	local cb3ClickHandler = function(checked)
		DCoordsDB["MainBar"].showSubZone  = checked;
	end
	local cb2 = DTools.createCheckbox(
		"cb3",addon.menu.mainBar,"Show sub zone?",
		x,y,
		DCoordsDB["MainBar"].showSubZone,
		cb3ClickHandler
	)
	y = y - 40; -- estimate height of item




	-- ACEGUI3.0 DropDown: Strata selection
	-- local dropDownStrataChangeHandler = function(obj,event,v)
	-- 	DCoordsDB["MainBar"].labelAnchorIndex = v;
	-- 	print("labelAnchorIndex = " .. DCoordsDB["MainBar"].labelAnchorIndex)
	-- 	addon.setMainBarAnchor();
	-- end
	-- local dropDownStrata = AceGUI:Create("Dropdown")
	-- dropDownStrata.frame:SetParent(addon.menu.mainBar)
	-- dropDownStrata.frame:SetFrameLevel(addon.menu.mainBar:GetFrameLevel() + 2)
	-- dropDownStrata:SetCallback("OnValueChanged", dropDownStrataChangeHandler)
	-- dropDownStrata.frame:SetPoint("TOPLEFT", x, y)
	-- dropDownStrata.frame:Show()
    -- dropDownStrata:SetLabel("Text expansion location:")
    -- -- dropDownStrata:SetList({
    -- --     ["choice1"] = "Text for Choice #1",
    -- --     ["choice2"] = "Text for Choice #2",
    -- --   })
    -- dropDownStrata:SetList(addon.menu.anchorOptions);
    -- dropDownStrata:SetValue(DCoordsDB["MainBar"].labelAnchorIndex) -- choice1 is checked initialy
    -- y = y - 70; -- estimate height of item







	-- ACEGUI3.0 DropDown: Background selection
	local dropDownBgChangeHandler = function(obj,event,v)
		DCoordsDB["MainBar"].backgroundIndex = v;
		addon.setMainBarBackground();
	end
	local dropDownBg = AceGUI:Create("Dropdown")
	dropDownBg.frame:SetParent(addon.menu.mainBar)
	dropDownBg.frame:SetFrameLevel(addon.menu.mainBar:GetFrameLevel() + 2)
	dropDownBg:SetCallback("OnValueChanged", dropDownBgChangeHandler)
	dropDownBg.frame:SetPoint("TOPLEFT", x, y)
	dropDownBg.frame:Show()
    dropDownBg:SetLabel("Background choice:")
    -- dropDownBg:SetList({
    --     ["choice1"] = "Text for Choice #1",
    --     ["choice2"] = "Text for Choice #2",
    --   })
    dropDownBg:SetList(addon.menu.backgroundOptions);
    dropDownBg:SetValue(DCoordsDB["MainBar"].backgroundIndex) -- choice1 is checked initialy
	y = y - 60; -- estimate height of item



	DTools.createText(addon.menu.mainBar,"Borderless background color (RGB A = Alpha)",addon.menu.textSize,"LEFT",x,y,1,0.8,0)
	y = y - 30; -- estimate height of item





	-- Sliders: r,g,b,a
	-- function(frame,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler,showEditBox)
    local sliderRedChangeHandler = function(val)
        DCoordsDB["MainBar"].bgR = val;
        addon.setMainBarBackground()
    end
    local min,max,step = 0,1,0.1;
	local sR = DTools.createSlider(
        addon.menu.mainBar,
        min,max,step,
        "Red",DCoordsDB["MainBar"].bgR,
        80,1,
        10,y,
        sliderRedChangeHandler,true
    )

    local sliderGreenChangeHandler = function(val)
        DCoordsDB["MainBar"].bgG = val;
        addon.setMainBarBackground()
    end
	local sG = DTools.createSlider(
        addon.menu.mainBar,
        min,max,step,
        "Green",DCoordsDB["MainBar"].bgG,
        80,1,
        100,y,
        sliderGreenChangeHandler,true
    )

    local sliderBlueChangeHandler = function(val)
        DCoordsDB["MainBar"].bgB = val;
        addon.setMainBarBackground()
    end
	local sB = DTools.createSlider(
        addon.menu.mainBar,
        min,max,step,
        "Blue",DCoordsDB["MainBar"].bgB,
        80,1,
        190,y,
        sliderBlueChangeHandler,true
    )

    local sliderAlphaChangeHandler = function(val)
        DCoordsDB["MainBar"].bgA = val;
        addon.setMainBarBackground()
    end
	local sA = DTools.createSlider(
        addon.menu.mainBar,
        min,max,step,
        "Alpha",DCoordsDB["MainBar"].bgA,
        80,1,
        280,y,
        sliderAlphaChangeHandler,true
    )
	y = y - 60; -- estimate height of item










	-- ACEGUI3.0 DropDown: Font selection
	local dropDownFontChangeHandler = function(obj,event,v)
		DCoordsDB["MainBar"].labelFontIndex = v;
		addon.setMainBarLabelStyle();
	end
	local dropDownFont = AceGUI:Create("Dropdown")
	dropDownFont.frame:SetParent(addon.menu.mainBar)
	dropDownFont.frame:SetFrameLevel(addon.menu.mainBar:GetFrameLevel() + 2)
	dropDownFont:SetCallback("OnValueChanged", dropDownFontChangeHandler)
	dropDownFont.frame:SetPoint("TOPLEFT", x, y)
	dropDownFont.frame:Show()
	dropDownFont:SetLabel("Font:")
	-- dropDownFont:SetList({
	--     ["choice1"] = "Text for Choice #1",
	--     ["choice2"] = "Text for Choice #2",
	--   })
	dropDownFont:SetList(addon.fonts);
	dropDownFont:SetValue(DCoordsDB["MainBar"].labelFontIndex) -- choice1 is checked initialy
	y = y - 70; -- estimate height of item




	-- Slider: font size
	-- function(frame,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler,showEditBox)
    local sliderFontSizeChangeHandler = function(val)
		DCoordsDB["MainBar"].labelFontSize  = val;
		addon.setMainBarLabelStyle();
    end
	local sliderFontSize = DTools.createSlider(
        addon.menu.mainBar,
        7,20,1,
        "Font size",
        DCoordsDB["MainBar"].labelFontSize,
        150,
        0,
        x,y,
        sliderFontSizeChangeHandler,
        true
    )



	-- Slider: offset x
	-- function(frame,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler,showEditBox)
    local sliderOffsetXChangeHandler = function(val)
		DCoordsDB["MainBar"].labelOffsetX  = val;
		addon.updateMainBarDimensions();
    end
	local sliderFontSize = DTools.createSlider(
        addon.menu.mainBar,
        -50,50,0.1,
        "Offset X",
        DCoordsDB["MainBar"].labelOffsetX,
        150,
        1,
        x+170,y,
        sliderOffsetXChangeHandler,
        true
    )


	-- Slider: offset Y
	-- function(frame,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler,showEditBox)
    local sliderOffsetYChangeHandler = function(val)
		DCoordsDB["MainBar"].labelOffsetY  = val;
		addon.updateMainBarDimensions();
    end
	local sliderFontSize = DTools.createSlider(
        addon.menu.mainBar,
        -50,50,0.1,
        "Offset Y",
        DCoordsDB["MainBar"].labelOffsetY,
        150,
        1,
        x+340,y,
        sliderOffsetYChangeHandler,
        true
    )
	y = y - 70; -- estimate height of item



	-- Slider: labelPaddingX
	-- function(frame,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler,showEditBox)
    local s1ChangeHandler = function(val)
		DCoordsDB["MainBar"].labelPaddingX  = val;
		addon.setMainBarBackground();
    end
	local s1 = DTools.createSlider(
        addon.menu.mainBar,
        0,50,0.01,
        "Padding left & right",
        DCoordsDB["MainBar"].labelPaddingX,
        150,
        1,
        x,y,
        s1ChangeHandler,
        true
    )



	-- Slider: labelPaddingY
	-- function(frame,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler,showEditBox)
    local s2ChangeHandler = function(val)
		DCoordsDB["MainBar"].labelPaddingY  = val;
    end
	local s1 = DTools.createSlider(
        addon.menu.mainBar,
        0,50,0.01,
        "Padding top & bottom",
        DCoordsDB["MainBar"].labelPaddingY,
        150,
        1,
        x+200,y,
        s2ChangeHandler,
        true
    )
    y = y - 60; -- estimate height of item



	-- Create addon sub page
	addon.menu.api.addPage("Main Bar",addon.menu.mainBar);
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #










addon.setupMenuWorldMap = function()
	local x = 10;
	local y = -10;

	-- Frame for the page
	-- DMouse.menu.mainPage = DTools.createTestFrame(400,400,"TOPLEFT",0,0); -- For visual without opening menu
	addon.menu.worldMap = CreateFrame( "Frame", "DCoordsMenuWorldMapPage", UIParent );

    -- Page title
    -- function(frame,label,fontSize,x,y,r,g,b,font)
    DTools.createText(addon.menu.worldMap,addon.name .. " v" .. addon.version .. " - World Map",addon.menu.titleTextSize,"LEFT",x,y,1,1,1)
	y = y - 40; -- estimate height of item


	-- Checkbox: Enable / Disable
	local cb1ClickHandler = function(checked)
		DCoordsDB["WorldMap"].enabled  = checked;
		addon.initWorldMapState();
	end
	local cb1 = DTools.createCheckbox(
		"cb1",addon.menu.worldMap,"Enable coordinates on world map?",
		x,y,
		DCoordsDB["WorldMap"].enabled,
		cb1ClickHandler
	)
	y = y - 50; -- estimate height of item



	-- Slider: font size
	-- function(frame,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler,showEditBox)
    local sliderFontSizeChangeHandler = function(val)
		DCoordsDB["WorldMap"].fontSize  = val;
		addon.setWorldMapFontStyles();
    end
	local sliderFontSize = DTools.createSlider(
        addon.menu.worldMap,
        7,20,1,
        "Font size",
        DCoordsDB["WorldMap"].fontSize,
        150,
        0,
        x,y,
        sliderFontSizeChangeHandler,
        true
	)
	y = y - 50; -- estimate height of item



	-- ACEGUI3.0 DropDown: Font selection
	local dropDownFontChangeHandler = function(obj,event,v)
		DCoordsDB["WorldMap"].fontIndex = v;
		addon.setWorldMapFontStyles();
	end
	local dropDownFont = AceGUI:Create("Dropdown")
	dropDownFont.frame:SetParent(addon.menu.worldMap)
	dropDownFont.frame:SetFrameLevel(addon.menu.worldMap:GetFrameLevel() + 2)
	dropDownFont:SetCallback("OnValueChanged", dropDownFontChangeHandler)
	dropDownFont.frame:SetPoint("TOPLEFT", x, y)
	dropDownFont.frame:Show()
	dropDownFont:SetLabel("Font:")
	-- dropDownFont:SetList({
	--     ["choice1"] = "Text for Choice #1",
	--     ["choice2"] = "Text for Choice #2",
	--   })
	dropDownFont:SetList(addon.fonts);
	dropDownFont:SetValue(DCoordsDB["WorldMap"].fontIndex) -- choice1 is checked initialy
	y = y - 70; -- estimate height of item





	-- ACEGUI3.0 DropDown: world map coordinates pos change handler
	local ddPosChangeHandler = function(obj,event,v)
		DCoordsDB["SelectedWorldMapPosIndex"] = v;
		addon.setWorldMapLabelPosition();
	end
	local ddPos = AceGUI:Create("Dropdown")
	ddPos.frame:SetParent(addon.menu.worldMap)
	ddPos.frame:SetFrameLevel(addon.menu.mainBar:GetFrameLevel() + 2)
	ddPos:SetCallback("OnValueChanged", ddPosChangeHandler)
	ddPos.frame:SetPoint("TOPLEFT", x, y)
	ddPos.frame:Show()
	ddPos:SetLabel("WorldMap Coordinates Position:")
	-- ddPos:SetList({
	--     ["choice1"] = "Text for Choice #1",
	--     ["choice2"] = "Text for Choice #2",
	--   })
	ddPos:SetList(addon.menu.worldMapPos);
	ddPos:SetValue(DCoordsDB["SelectedWorldMapPosIndex"]) -- choice1 is checked initialy
	y = y - 70; -- estimate height of item








	-- Slider: offset x
	-- function(frame,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler,showEditBox)
    local sliderOffsetXChangeHandler = function(val)
		DCoordsDB["WorldMap"].offsetX  = val;
		addon.setWorldMapLabelPosition();
    end
	local sliderFontSize = DTools.createSlider(
        addon.menu.worldMap,
        -15,1500,0.1,
        "Offset X",
        DCoordsDB["WorldMap"].offsetX,
        250,
        1,
        x,y,
        sliderOffsetXChangeHandler,
        true
    )


	-- Slider: offset Y
	-- function(frame,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler,showEditBox)
    local sliderOffsetYChangeHandler = function(val)
		DCoordsDB["WorldMap"].offsetY  = val;
		addon.setWorldMapLabelPosition();
    end
	local sliderFontSize = DTools.createSlider(
        addon.menu.worldMap,
        -800,15,0.1,
        "Offset Y",
        DCoordsDB["MainBar"].offsetY,
        250,
        1,
        x+270,y,
        sliderOffsetYChangeHandler,
        true
    )
	y = y - 60; -- estimate height of item










	-- Create addon sub page
	addon.menu.api.addPage("World Map",addon.menu.worldMap);
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #













addon.setupMenuMiniMap = function()
	local x = 10;
	local y = -10;

	-- Frame for the page
	-- DMouse.menu.mainPage = DTools.createTestFrame(400,400,"TOPLEFT",0,0); -- For visual without opening menu
	addon.menu.miniMap = CreateFrame( "Frame", "DCoordsMenuMiniMapPage", UIParent );

    -- Page title
    -- function(frame,label,fontSize,x,y,r,g,b,font)
    DTools.createText(addon.menu.miniMap,addon.name .. " v" .. addon.version .. " - Mini Map",addon.menu.titleTextSize,"LEFT",x,y,1,1,1)
	y = y - 40; -- estimate height of item



	-- Message
    -- function(frame,label,fontSize,x,y,r,g,b,font)
    DTools.createText(addon.menu.miniMap,"Comming soon to a cinema near you...",addon.menu.textSize,"LEFT",x,y,0.8,1,0.8)
	y = y - 40; -- estimate height of item


	-- Create addon sub page
	addon.menu.api.addPage("Mini Map",addon.menu.miniMap);
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
