--[[
	Author: Darcey.Lloyd@gmail.com

	USEFUL TO GET FRAME NAME IN GAME CHAT:
	/run print(GetMouseFocus():GetName() .. "\n")
--]]



-- Addon Global Variables (shared between files but not addons). addon var name can be renamed
local AddOnName, addon = ...;
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #








-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
addon.getCoords = function(decimalPrecision)
	if (not decimalPrecision) then
		decimalPrecision = 1;
	end
    local mapID = C_Map.GetBestMapForUnit("player");
    local coords = "";
    if (mapID) then
        local position = C_Map.GetPlayerMapPosition(mapID,"player") -- Memory leak on this (nothing I can do about it bliz!)
        if (position) then
            x = position.x * 100;
            y = position.y * 100;
			-- x = math.floor(x*100)/100; -- string.format("%.2f",position.x);
			local precision = "%.".. decimalPrecision .."f";
			x = string.format(precision, x);
			y = string.format(precision, y);
			coords = {}
			coords.x = x
			coords.y = y
            return coords;
        else
            return nil;
		end
	else
		return nil;
    end

end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #










-- addon.GetZoneDetails
addon.getZoneDetails = function()
	-- Should only be run on event change from eventFrame
	addon.location.zone = GetZoneText()
	addon.location.subZone = GetSubZoneText()

	if (addon.location.zone ~= "") and (addon.location.subZone ~= "") then
		addon.location.label = addon.location.zone .. " - " .. addon.location.subZone;
	elseif (addon.location.zone == "") and (addon.location.subZone ~= "") then
		addon.location.label = addon.location.subZone;
	elseif (addon.location.zone ~= "") and (addon.location.subZone == "") then
		addon.location.label = addon.location.zone;
	else
		addon.location.label = "";
	end

	if (addon.debug) then
		DTools.log("addon.location.subZone = " .. addon.location.subZone , "00CC00")
		DTools.log("addon.location.zone = " .. addon.location.zone , "00CC00")
		DTools.log("addon.location.label = " .. addon.location.label , "00CC00")
	end
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



addon.getCursorWorldMapCoords = function()

	local WorldMapScrollChild = WorldMapFrame.ScrollContainer.Child;
	local left, top = WorldMapScrollChild:GetLeft(), WorldMapScrollChild:GetTop()
	local width, height = WorldMapScrollChild:GetWidth(), WorldMapScrollChild:GetHeight()
	local scale = WorldMapScrollChild:GetEffectiveScale()

	local x, y = GetCursorPosition()
	local cx = (x/scale - left) / width
	local cy = (top - y/scale) / height

	if cx < 0 or cx > 1 or cy < 0 or cy > 1 then
		return
	end

	return cx, cy
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



addon.getMainBarFont = function()
	local font = addon.sharedMedia:Fetch("font","Font "..DCoordsDB["MainBar"].labelFontIndex,true);
	return font;
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



addon.getWorldMapFont = function()
	local font = addon.sharedMedia:Fetch("font","Font "..DCoordsDB["WorldMap"].fontIndex,true);
	return font;
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
